// 完毕：
using System;
using System.IO;
using System.Drawing;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Text;
using GCTEXT = GrapeCity.Documents.Text;
using GCDRAW = GrapeCity.Documents.Drawing;

namespace DsPdfWeb.Demos.Basics
{
    // PDF 规范列出了 14 种应始终可用的标准字体。
    // GcDocs.Pdf 内置了这些字体，并允许您直接使用它们，如本示例所示。
    public class StandardPdfFonts
    {
        public int CreatePDF(Stream stream)
        {
            var doc = new GcPdfDocument();
            var g = doc.NewPage().Graphics;
            // 插入点（GcDocs.Pdf的默认分辨率为72dpi，周围使用1英寸边距）：
            const float margin = 72;
            var ip = new PointF(margin, margin);
            var tf = new TextFormat() { FontSize = 12 };
            Action<string, GCTEXT.Font> drawText = (tag_, fnt_) =>
            {
                tf.Font = fnt_;
                string tstr = $"{tag_} ({fnt_.FullFontName}): The quick brown fox jumps over the lazy dog.";
                var s = g.MeasureString(tstr, tf, doc.PageSize.Width - margin * 2);
                g.DrawString(tstr, tf, new RectangleF(ip, s));
                ip.Y += s.Height * 1.5f;
            };
            // 绘制所有 14 种标准字体的样本：
            drawText("Helvetica", StandardFonts.Helvetica);
            drawText("HelveticaItalic", StandardFonts.HelveticaItalic);
            drawText("HelveticaBold", StandardFonts.HelveticaBold);
            drawText("HelveticaBoldItalic", StandardFonts.HelveticaBoldItalic);
            drawText("Times", StandardFonts.Times);
            drawText("TimesItalic", StandardFonts.TimesItalic);
            drawText("TimesBold", StandardFonts.TimesBold);
            drawText("TimesBoldItalic", StandardFonts.TimesBoldItalic);
            drawText("Courier", StandardFonts.Courier);
            drawText("CourierItalic", StandardFonts.CourierItalic);
            drawText("CourierBold", StandardFonts.CourierBold);
            drawText("CourierBoldItalic", StandardFonts.CourierBoldItalic);
            drawText("Symbol", StandardFonts.Symbol);
            drawText("ZapfDingbats", StandardFonts.ZapfDingbats);
            // 完毕：
            doc.Save(stream);
            return doc.Pages.Count;
        }
    }
}
